<?php

namespace Plugins\KuaiDi100;

/**
 * Class Client
 */
class Client
{
    public static function get(string $url, array $query = [])
    {

    }

    public static function post(string $url, array $data)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(self::getRequestData($data)));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $result = curl_exec($ch);

        var_dump($result);
        return json_decode($result, true) ?? [];
    }

    /**
     * @param array $data
     *
     * @return array
     */
    private static function getRequestData(array $data): array
    {
        $customer = \Hyperf\Config\config('plugins.KuaiDi100.customer');
        $key      = \Hyperf\Config\config('plugins.KuaiDi100.key');

        $post_data             = [];
        $post_data['param']    = json_encode($data, JSON_UNESCAPED_UNICODE);
        $post_data['customer'] = $customer;
        $post_data['sign']     = strtoupper(md5($post_data['param'] . $key . $post_data['customer']));

        return $post_data;
    }
}